%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif

%if %{defined nodebug}
%global debug_package      %{nil}
%endif

Name: libqmail
Version: 1.2
Release: 1.1%{?dist}
Summary: Library for qmail
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: System/Libraries
%endif
%if %build_on_obs == 1
License: GPL-2.0
%else
License: GPLv2
%endif
URL: https://github.com/mbhangui/libqmail
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
%global see_base For a description of IndiMail visit http://www.indimail.org
%global mandir %{_prefix}/share/man
%global _pkg_config_path   /usr/%{_lib}/pkgconfig
BuildRequires: rpm gcc gcc-c++ make binutils coreutils grep
BuildRequires: glibc glibc-devel openssl-devel sed
BuildRequires: gzip autoconf automake libtool pkgconfig
BuildRequires: xz
%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks  
#!BuildIgnore: post-build-checks  
%endif
%endif

AutoReqProv: Yes
Provides: qmail-libs = %{version}
Provides: qmail-libs%{?_isa} = %{version}

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
libqmail provides qmail libraries
Included APIs:
* wrappers around memory allocation, stralloc (dynamic strings)
* substdio buffered I/O
* byte - contains formatting, scanning and other string routines
* tai - contains an abstraction for 64-bit system time
* timeout - contains versions of several socket routines with user specified
  timeout
* unix - contains wrappers for socket functions, mkfifo, opendir, wait and an
  abstraction around errno.
* sig - contains wrappers for Unix signal functions

%{see_base}

%package -n libqmail-devel
Summary: Development header files and libraries for qmail
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: Development/Tools/Other
%endif
Requires: libqmail >= %{version}

%description -n libqmail-devel
This package contains the development header files and libraries
necessary to develop qmail applications

%{see_base}

%prep
%setup -q

%build
%configure --prefix=/usr --sysconfdir=/etc/indimail

%install
%{__make} -s %{?_smp_mflags}
%if %{defined nodebug}
  %{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install-strip
%else
  %{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install
%endif
%{__rm} -f %{buildroot}%{_libdir}/libqmail.la

%clean
[ "%{buildroot}" = "/" ] || rm -rf "%{buildroot}"

%files
%defattr(-, root, root, 0755)
%{_libdir}/libqmail.so.1
%{_libdir}/libqmail.so.1.0.0

%doc doc/ChangeLog COPYING README.md

%files devel
%defattr(-, root, root, 0755)
%dir %attr(755,root,root)               %{_prefix}/include/qmail
%doc %attr(644,root,root)               %{mandir}/man3/*

%attr(644,root,root)                    %{_prefix}/include/qmail/alloc.h
%attr(644,root,root)                    %{_prefix}/include/qmail/base64.h
%attr(644,root,root)                    %{_prefix}/include/qmail/builtinoflmacros.h
%attr(644,root,root)                    %{_prefix}/include/qmail/byte.h
%attr(644,root,root)                    %{_prefix}/include/qmail/caldate.h
%attr(644,root,root)                    %{_prefix}/include/qmail/caltime.h
%attr(644,root,root)                    %{_prefix}/include/qmail/case.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdb.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdb_make.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdbmake.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdbmss.h
%attr(644,root,root)                    %{_prefix}/include/qmail/check_domain.h
%attr(644,root,root)                    %{_prefix}/include/qmail/coe.h
%attr(644,root,root)                    %{_prefix}/include/qmail/constmap.h
%attr(644,root,root)                    %{_prefix}/include/qmail/date822fmt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/datetime.h
%attr(644,root,root)                    %{_prefix}/include/qmail/digest_md5.h
%attr(644,root,root)                    %{_prefix}/include/qmail/direntry.h
%attr(644,root,root)                    %{_prefix}/include/qmail/env.h
%attr(644,root,root)                    %{_prefix}/include/qmail/envdir.h
%attr(644,root,root)                    %{_prefix}/include/qmail/error.h
%attr(644,root,root)                    %{_prefix}/include/qmail/evaluate.h
%attr(644,root,root)                    %{_prefix}/include/qmail/fd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/fifo.h
%attr(644,root,root)                    %{_prefix}/include/qmail/fmt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/hasbltnofl.h
%attr(644,root,root)                    %{_prefix}/include/qmail/hmac.h
%attr(644,root,root)                    %{_prefix}/include/qmail/in_crypt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/iopause.h
%attr(644,root,root)                    %{_prefix}/include/qmail/gen_allocdefs.h
%attr(644,root,root)                    %{_prefix}/include/qmail/gen_alloc.h
%attr(644,root,root)                    %{_prefix}/include/qmail/getEnvConfig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/getln.h
%attr(644,root,root)                    %{_prefix}/include/qmail/global.h
%attr(644,root,root)                    %{_prefix}/include/qmail/commands.h
%attr(644,root,root)                    %{_prefix}/include/qmail/rewritehost.h
%attr(644,root,root)                    %{_prefix}/include/qmail/leapsecs.h
%attr(644,root,root)                    %{_prefix}/include/qmail/lock.h
%attr(644,root,root)                    %{_prefix}/include/qmail/makeargs.h
%attr(644,root,root)                    %{_prefix}/include/qmail/makesalt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/md5.h
%attr(644,root,root)                    %{_prefix}/include/qmail/mess822.h
%attr(644,root,root)                    %{_prefix}/include/qmail/mkpasswd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/mktempfile.h
%attr(644,root,root)                    %{_prefix}/include/qmail/ndelay.h
%attr(644,root,root)                    %{_prefix}/include/qmail/noreturn.h
%attr(644,root,root)                    %{_prefix}/include/qmail/now.h
%attr(644,root,root)                    %{_prefix}/include/qmail/no_of_days.h
%attr(644,root,root)                    %{_prefix}/include/qmail/open.h
%attr(644,root,root)                    %{_prefix}/include/qmail/openreadclose.h
%attr(644,root,root)                    %{_prefix}/include/qmail/pathexec.h
%attr(644,root,root)                    %{_prefix}/include/qmail/prot.h
%attr(644,root,root)                    %{_prefix}/include/qmail/pw_comp.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qgetpwgr.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qprintf.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qtime.h
%attr(644,root,root)                    %{_prefix}/include/qmail/readclose.h
%attr(644,root,root)                    %{_prefix}/include/qmail/replacestr.h
%attr(644,root,root)                    %{_prefix}/include/qmail/ripemd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/r_mkdir.h
%attr(644,root,root)                    %{_prefix}/include/qmail/scan.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sconfig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/seek.h
%attr(644,root,root)                    %{_prefix}/include/qmail/select.h
%attr(644,root,root)                    %{_prefix}/include/qmail/setuserid.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sgetopt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sha1.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/stralloc.h
%attr(644,root,root)                    %{_prefix}/include/qmail/strerr.h
%attr(644,root,root)                    %{_prefix}/include/qmail/strmsg.h
%attr(644,root,root)                    %{_prefix}/include/qmail/str.h
%attr(644,root,root)                    %{_prefix}/include/qmail/subfd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/subgetopt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/substdio.h
%attr(644,root,root)                    %{_prefix}/include/qmail/taia.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tai.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tai2.h
%attr(644,root,root)                    %{_prefix}/include/qmail/timeoutread.h
%attr(644,root,root)                    %{_prefix}/include/qmail/timeoutwrite.h
%attr(644,root,root)                    %{_prefix}/include/qmail/timestamp.h
%attr(644,root,root)                    %{_prefix}/include/qmail/token822.h
%attr(644,root,root)                    %{_prefix}/include/qmail/typesx.h
%attr(644,root,root)                    %{_prefix}/include/qmail/uint16.h
%attr(644,root,root)                    %{_prefix}/include/qmail/uint32.h
%attr(644,root,root)                    %{_prefix}/include/qmail/uint64.h
%attr(644,root,root)                    %{_prefix}/include/qmail/wait.h
%attr(644,root,root)                    %{_prefix}/include/qmail/array.h
%attr(644,root,root)                    %{_prefix}/include/qmail/entities.h
%attr(644,root,root)                    %{_prefix}/include/qmail/textcode.h
%attr(644,root,root)                    %{_prefix}/include/qmail/iarray.h
%attr(644,root,root)                    %{_prefix}/include/qmail/likely.h
%attr(644,root,root)                    %{_prefix}/include/qmail/safemult.h
%attr(644,root,root)                    %{_prefix}/include/qmail/rangecheck.h

%{_libdir}/libqmail.so
%{_libdir}/libqmail.a
%{_pkg_config_path}/libqmail.pc

%post
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
if [ "$argv1" -eq 2 ] ; then # upgrade
  # we are doing upgrade
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    /sbin/ldconfig
  fi
fi

%postun
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  /sbin/ldconfig
fi

%changelog
* Sun Sep 12 2021 13:17:07 +0000 Manvendra Bhangui <libqmail@indimail.org> 1.2-1.1%{?dist}
Release 1.1.1 Start 18/07/2021
- added r_mkdir function
- qgetpwgr.c: added qgetserv.. functions to read /etc/services
- envdir.c: set variables from .envdir first to prevent .envdir from overriding
  main
- envdir.c: added feature to process .envfile and .envdir as a file
  containing list of directories
- envdir.c: return directory/filenames in error
- pathexec.[c,h]: added pathexec_clear() to clear env variables
- envdir.c: refactored to remove use of chdir to traverse directories.
- str.h: fixed prototypes (str_chr, str_chrn, str_rchr) use const char '*'
- envdir.c: treat openreadclose returning 0 as an error
- configure.ac, qgetpwgr.c: added arpa/inet.h for htons()
- added no_of_days() function
- strerr.h, strerr_die.c, strerr_sys.c: added addtional members to struct
  strerr
- added check_domain() function
- added noreturn.h for defining noreturn
- strerr.h: use noreturn instead of __attribute__((noreturn))
- added replacestr function
